---
policy: /ce/ca/azure/app-service/https-only-configuration
logic: /ce/ca/azure/app-service/https-only-configuration/prod.logic.yaml
executionTime: 2025-04-24T23:45:17.980665536Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__httpsOnly__c') == 'Disabled'
      actual: extract('CA10__httpsOnly__c') == 'Disabled'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__httpsOnly__c') == 'Enabled'
      actual: extract('CA10__httpsOnly__c') == 'Enabled'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/azure/app-service/https-only-configuration/policy.yaml
    md5Hash: 427AC86728AD71F936886E30AAAE8C42
    content: |
      ---
      names:
        full: Azure App Service HTTPS Only configuration is not enabled
        contextual: HTTPS Only configuration is not enabled
      description: Azure Web Apps allows sites to run under both HTTP and HTTPS by default.
        Web apps can be accessed by anyone using non-secure HTTP links by default. Non-secure
        HTTP requests can be restricted and all HTTP requests redirected to the secure HTTPS
        port. It is recommended to enforce HTTPS-only traffic.
      type: COMPLIANCE_POLICY
      categories:
        - SECURITY
      frameworkMappings:
        - "/frameworks/cis-azure-v2.1.0/09/02"
        - "/frameworks/cis-azure-v3.0.0/09/01"
        - "/frameworks/cloudaware/resource-security/data-encryption"
      similarPolicies:
        internal:
          - dec-x-75db76ad
        cloudConformity:
          - url: https://www.trendmicro.com/cloudoneconformity/knowledge-base/azure/AppService/enable-https-only-traffic.html
            name: Enable HTTPS-Only Traffic
  - path: /ce/ca/azure/app-service/https-only-configuration/prod.logic.yaml
    md5Hash: CD3F2F51A84E92CBDC8079E5D4110A64
    content: |
      ---
      inputType: "CA10__CaAzureAppService__c"
      importExtracts:
        - file: "/types/CA10__CaAzureAppService__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "App Service HTTPS Only configuration is disabled."
          remediationMessage: "Consider enabling App Service HTTPS Only configuration."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__httpsOnly__c"
              right:
                TEXT: "Disabled"
        - status: "COMPLIANT"
          currentStateMessage: "App Service HTTPS Only configuration is enabled."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__httpsOnly__c"
              right:
                TEXT: "Enabled"
      otherwise:
        status: "UNDETERMINED"
        currentStateMessage: "Unexpected value in the field."
  - path: /types/CA10__CaAzureAppService__c/object.extracts.yaml
    md5Hash: BA4130C0EACD0EA4C609D6BD75139054
    content: "---\nextracts:\n# Values: Enabled, Disabled. Not Nullable.\n  - name:\
      \ \"CA10__authStatus__c\"\n    value: \n      FIELD:\n        path: \"CA10__authStatus__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__authStatus__c\"\n            currentStateMessage: \"Unable to determine\
      \ Auth Settings. Possible permission issue with Microsoft.Web/sites/config/authsettings/list\"\
      \n# Values: Enabled, Disabled. Not Nullable.\n  - name: \"CA10__basicPublishingCredentialsFtpState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__basicPublishingCredentialsFtpState__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__basicPublishingCredentialsFtpState__c\"\n            currentStateMessage:\
      \ \"Unable to determine Basic Auth Settings. Possible permission issue with\
      \ Microsoft.Web/sites/basicPublishingCredentialsPolicies\"\n# Values: Enabled,\
      \ Disabled. Not Nullable.\n  - name: \"CA10__basicPublishingCredentialsScmState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__basicPublishingCredentialsScmState__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__basicPublishingCredentialsScmState__c\"\n            currentStateMessage:\
      \ \"Unable to determine Basic Auth Settings. Possible permission issue with\
      \ Microsoft.Web/sites/basicPublishingCredentialsPolicies\"\n# Values: Enabled,\
      \ Disabled. Not Nullable. Can't have no access, retrieved via Microsoft.Web/sites\n\
      \  - name: \"CA10__httpsOnly__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__httpsOnly__c\"\n        undeterminedIf:\n          isEmpty: \"Corrupted\
      \ data. HTTPS Only configuration cannot be empty.\"\n# Values: 1.0, 1.1, 1.2.\
      \ Not Nullable.\n  - name: \"CA10__configMinTlsVersion__c\"\n    value: \n \
      \     FIELD:\n        path: \"CA10__configMinTlsVersion__c\"\n        undeterminedIf:\n\
      \          noAccessDelegate:\n            path: \"CA10__configMinTlsVersion__c\"\
      \n            currentStateMessage: \"Unable to determine minimum version of\
      \ TLS. Possible permission issue with Microsoft.Web/sites/config/web/read\"\n\
      # Nullable. Can't have no access, retrieved via Microsoft.Web/sites\n  - name:\
      \ \"CA10__identityPrincipalId__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__identityPrincipalId__c\"\n# Values: Enabled, Disabled. Not Nullable.\n\
      \  - name: \"CA10__configHttp20__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__configHttp20__c\"\n        undeterminedIf:\n          noAccessDelegate:\n\
      \            path: \"CA10__configHttp20__c\"\n            currentStateMessage:\
      \ \"Unable to determine HTTP2.0 configuration. Possible permission issue with\
      \ Microsoft.Web/sites/config/web/read\"\n# Values: AllAllowed, Disabled, FtpsOnly.\
      \ Not Nullable.\n  - name: \"CA10__configFtpsState__c\"\n    value: \n     \
      \ FIELD:\n        path: \"CA10__configFtpsState__c\"\n        undeterminedIf:\n\
      \          noAccessDelegate:\n            path: \"CA10__configFtpsState__c\"\
      \n            currentStateMessage: \"Unable to determine FTPS State. Possible\
      \ permission issue with Microsoft.Web/sites/config/web/read\"\n# Values: Enabled,\
      \ Disabled. Not Nullable.\n  - name: \"CA10__configRemoteDebugging__c\"\n  \
      \  value: \n      FIELD:\n        path: \"CA10__configRemoteDebugging__c\"\n\
      \        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__configRemoteDebugging__c\"\n            currentStateMessage: \"Unable\
      \ to determine FTPS State. Possible permission issue with Microsoft.Web/sites/config/web/read\"\
      \n"
  - path: /ce/ca/azure/app-service/https-only-configuration/test-data.json
    md5Hash: 63358B91570A2973F0E6F089377704CA
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2024-06-20T20:56:36Z",
              "CA10__httpsOnly__c": "Enabled"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__httpsOnly__c') == 'Disabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__httpsOnly__c": "Disabled"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "extract('CA10__httpsOnly__c') == 'Enabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__httpsOnly__c": "Enabled"
          }
      ]
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__httpsOnly__c') == 'Disabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__httpsOnly__c') == 'Enabled'",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAzureAppService__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__httpsOnly__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2024-06-20T20:56:36Z"),
    "CA10__httpsOnly__c" : "Enabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test2",
    "CA10__httpsOnly__c" : "Disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test3",
    "CA10__httpsOnly__c" : "Enabled"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAzureAppService__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__httpsOnly__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Azure [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__httpsOnly__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__httpsOnly__c.isEmpty()", currentStateMessage: "Corrupted data. HTTPS Only configuration cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__httpsOnly__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('HTTPS Only [obj.CA10__httpsOnly__c]: ' + obj.CA10__httpsOnly__c);
      try {
          if (TextLib.equal(extract3.call(extract3), 'Disabled')) {
              return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__httpsOnly__c') == 'Disabled'", currentStateMessage: "App Service HTTPS Only configuration is disabled.", currentStateReferences: references1.join('\n'), remediation: "Consider enabling App Service HTTPS Only configuration.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function fieldChecked7() {
          if (TextLib.isEmpty(obj.CA10__httpsOnly__c)) {
              throw new Error("UNDETERMINED condition:201", {cause: {status: 'UNDETERMINED', conditionIndex: 201, conditionText: "CA10__httpsOnly__c.isEmpty()", currentStateMessage: "Corrupted data. HTTPS Only configuration cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__httpsOnly__c;
      }
      function extract6() { if (!this.out) { this.out = fieldChecked7(); } return this.out; };
      try {
          if (TextLib.equal(extract6.call(extract6), 'Enabled')) {
              return {status: 'COMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__httpsOnly__c') == 'Enabled'", currentStateMessage: "App Service HTTPS Only configuration is enabled.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'UNDETERMINED', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "Unexpected value in the field.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__httpsOnly__c AS CA10__httpsOnly__c,
          process_CA10__CaAzureAppService__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__httpsOnly__c AS CA10__httpsOnly__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAzureAppService__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
